---
product: "AG Grid"
title: "Reference Data"
description: "This section describes two different strategies for managing reference data in your application. Both approaches implement the same grid example so they can be easily compared."
framework: javascript
version: "36.2.0"
related:
    - title: "Cell Content"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-content/"
    - title: "Find"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/find/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/notes/"
    - title: "Styling Cells"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-styles/"
    - title: "Highlighting Changes"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/change-cell-renderers/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/tooltips/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-expressions/"
    - title: "View Refresh"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/view-refresh/"
    - title: "Cell Text Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/javascript-data-grid/cell-text-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Reference Data

This section describes two different strategies for managing reference data in your application. Both approaches implement the same grid example so they can be easily compared.

> **Note**
>
> The term **Reference Data** is used here in a general way to describe data which can be defined using a key / value pair relationship (e.g. `'tyt': 'Toyota'`). This data is typically static in nature, i.e. it is not expected to change between server requests.

The examples contained within this section use the following reference data. Note that the data returned from the server only contains codes (keys) which must be mapped to names (values) for display purposes.

```js
// data from server
const rowData = [
    { make: 'tyt', exteriorColour: 'fg', interiorColour: 'bw', price: 35000 },
    { make: 'frd', exteriorColour: 'bw', interiorColour: 'cb', price: 32000 },
    ...
]

// supporting reference data
const carMappings = {
    'tyt': 'Toyota',
    'frd': 'Ford',
    'prs': 'Porsche',
    'nss': 'Nissan'
};

const colourMappings = {
    'cb': 'Cadet Blue',
    'bw': 'Burlywood',
    'fg': 'Forest Green'
};
```

## Using Value Handlers

Value Handlers can be used to map keys contained within the row data to their corresponding display values. This approach involves more coding but allows for different data formats and offers more flexibility managing the data.

The main idea of this approach is to use a `valueFormatter` to convert the code (key) to a value which is displayed in the cell. Then use a `valueParser` to convert the name back to a code (key) when saving it down into the underlying data.

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'make',
            cellEditor: 'agSelectCellEditor',
            cellEditorParams: {
                values: extractKeys(carMappings)
            },
            // convert code to value
            valueFormatter: params => {
                return lookupValue(carMappings, params.value);
            },
            // convert value to code
            valueParser: params => {
                return lookupKey(carMappings, params.newValue);
            }
        }
    ],

    // other grid options ...
}
```

> **Note**
>
> When editing using Cell Editors it's important to ensure the underlying data is updated with the codes (keys) rather than the values that are displayed in the cells.

When using the `TextCellEditor` with a `valueFormatter`, you may want to display the formatted text rather than the code when editing. In this case you should also include the `useFormatter` property as follows:

```js
cellEditor: 'agTextCellEditor',
cellEditorParams: {
    useFormatter: true
}
```

### Example: Value Handlers

The following example demonstrates how `Value Handlers` can be combined to work with reference data:

- **'Make' Column:** uses the built-in `'select'` Cell Editor. Mapped names are displayed in the dropdown list and selections are saved as `'make'` codes in the underlying data.
- **'Exterior Colour' Column:** uses the built-in `'richSelect'` Cell Editor. Mapped names are displayed in the dropdown list and selections are saved as `'colour'` codes in the underlying data.
- **'Interior Colour' Column:** uses a Text Cell Editor with `useFormatter=true`. Mapped names are displayed in the cells and edited values are saved as `'colour'` codes in the underlying data. (Note: a valid name must be entered or the value will be saved as undefined.)
- **Set Filters:** display a list of names rather than codes.
- **'Price' Columns:** additionally demonstrate the use of `valueGetters` and `valueSetters`.

#### Value Handlers

```ts
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ISetFilterParams,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  ValueSetterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { ColourCellRenderer } from "./colourCellRenderer";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
  SelectEditorModule,
  TextEditorModule,
]);

const carMappings = {
  tyt: "Toyota",
  frd: "Ford",
  prs: "Porsche",
  nss: "Nissan",
};

const colourMappings = {
  cb: "Cadet Blue",
  bw: "Burlywood",
  fg: "Forest Green",
};

function extractKeys(mappings: Record<string, string>) {
  return Object.keys(mappings);
}

const carCodes = extractKeys(carMappings);
const colourCodes = extractKeys(colourMappings);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    {
      field: "make",
      minWidth: 100,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: carCodes,
      },
      filterParams: {
        valueFormatter: (params: ValueFormatterParams) => {
          return lookupValue(carMappings, params.value);
        },
      },
      valueFormatter: (params) => {
        return lookupValue(carMappings, params.value);
      },
    },
    {
      field: "exteriorColour",
      minWidth: 150,
      cellEditor: "agRichSelectCellEditor",
      cellEditorParams: {
        values: colourCodes,
        cellRenderer: ColourCellRenderer,
      },
      filter: "agSetColumnFilter",
      filterParams: {
        values: colourCodes,
        valueFormatter: (params) => {
          return lookupValue(colourMappings, params.value);
        },
        cellRenderer: ColourCellRenderer,
      } as ISetFilterParams,
      valueFormatter: (params) => {
        return lookupValue(colourMappings, params.value);
      },
      valueParser: (params) => {
        return lookupKey(colourMappings, params.newValue);
      },
      cellRenderer: ColourCellRenderer,
    },
    {
      field: "interiorColour",
      minWidth: 150,
      cellEditor: "agTextCellEditor",
      cellEditorParams: {
        useFormatter: true,
      },
      filter: "agSetColumnFilter",
      filterParams: {
        values: colourCodes,
        valueFormatter: (params: ValueFormatterParams) => {
          return lookupValue(colourMappings, params.value);
        },
        cellRenderer: ColourCellRenderer,
      },
      valueFormatter: (params) => {
        return lookupValue(colourMappings, params.value);
      },
      valueParser: (params) => {
        return lookupKey(colourMappings, params.newValue);
      },
      cellRenderer: ColourCellRenderer,
    },
    {
      headerName: "Retail Price",
      field: "price",
      minWidth: 120,
      colId: "retailPrice",
      valueGetter: (params) => {
        return params.data.price;
      },
      valueFormatter: currencyFormatter,
      valueSetter: numberValueSetter,
    },
    {
      headerName: "Retail Price (incl Taxes)",
      minWidth: 120,
      editable: false,
      valueGetter: (params) => {
        // example of chaining value getters
        return params.getValue("retailPrice") * 1.2;
      },
      valueFormatter: currencyFormatter,
    },
  ],
  defaultColDef: {
    flex: 1,
    filter: true,
    editable: true,
  },
  rowData: getData(),
  onCellValueChanged: onCellValueChanged,
};

function onCellValueChanged(params: CellValueChangedEvent) {
  // notice that the data always contains the keys rather than values after editing
  console.log("onCellValueChanged Data: ", params.data);
}

function lookupValue(mappings: Record<string, string>, key: string) {
  return mappings[key];
}

function lookupKey(mappings: Record<string, string>, name: string) {
  const keys = Object.keys(mappings);

  for (let i = 0; i < keys.length; i++) {
    const key = keys[i];

    if (mappings[key] === name) {
      return key;
    }
  }
}

function currencyFormatter(params: ValueFormatterParams) {
  const value = Math.floor(params.value);

  if (isNaN(value)) {
    return "";
  }

  return "£" + value.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
}

function numberValueSetter(params: ValueSetterParams) {
  const valueAsNumber = parseFloat(params.newValue);
  if (isNaN(valueAsNumber) || !isFinite(params.newValue)) {
    return false; // don't set invalid numbers!
  }

  params.data.price = valueAsNumber;

  return true;
}

// wait for the document to be loaded, otherwise
// AG Grid will not find the div in the document.
// lookup the container we want the Grid to use
const eGridDiv = document.querySelector<HTMLElement>("#myGrid")!;

// create the grid passing in the div to use together with the columns & data we want to use
gridApi = createGrid(eGridDiv, gridOptions);
```

[Live example: Value Handlers](https://www.ag-grid.com/archive/36.2.0/examples/reference-data/ref-data-value-handler/typescript/)

## Using the 'refData' Property

Here we present the same example but this time using the `refData` ColDef property. This approach requires less coding and is more straightforward, but might not be flexible enough for scenarios involving more complex reference data formats.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refData` | `RefData` |  |  |  |

All that is required with this approach is to specify the `refData` and the grid will take care of the rest, as shown below:

```js
const gridOptions = {
    columnDefs: [
        {
            field: 'make',
            cellEditor: 'agSelectCellEditor',
            cellEditorParams: {
               values: extractKeys(carMappings)
            },
            refData: carMappings
        }
    ],

    // other grid options ...
}
```

Like in the previous example using Value Handlers, where the underlying data contains codes, the grid will use the specified reference data to display the associated values in the cells and save down the codes (keys) in the data when editing.

When a column with `refData` is used as a pivot column, the mapped display values are also used for the pivot column group headers.

### Example: 'refData' Property

The following example demonstrates how the `refData` property simplifies working with reference data:

- **'Make' Column:** uses the built-in `'select'` Cell Editor with the `refData` property specified. Mapped names are displayed in the dropdown list and selections are saved as `'make'` codes in the underlying data.
- **'Exterior Colour' Column:** uses the built-in `'richSelect'` Cell Editor with the `refData` property specified. Mapped names are displayed in the dropdown list and selections are saved as `'colour'` codes in the underlying data.
- **'Interior Colour' Column:** uses a Text Cell Editor (not recommended) with `refData`. Mapped names are displayed in the cells but when editing, colour codes (`cb`,`bw`,`fg`) must be entered directly. As users should not know codes, the Text Cell Editor is not recommended for use with `refData` in real world applications.
- **Set Filters:** display a list of names rather than codes.
- **'Price' Columns:** additionally demonstrate the use of `valueGetters` and `valueSetters`.

#### Ref Data Property

```ts
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  ValueSetterParams,
  createGrid,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { ColourCellRenderer } from "./colourCellRenderer";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
  SelectEditorModule,
  TextEditorModule,
]);

const carMappings = {
  tyt: "Toyota",
  frd: "Ford",
  prs: "Porsche",
  nss: "Nissan",
};

const colourMappings = {
  cb: "Cadet Blue",
  bw: "Burlywood",
  fg: "Forest Green",
};

function extractKeys(mappings: Record<string, string>) {
  return Object.keys(mappings);
}

const carCodes = extractKeys(carMappings);
const colourCodes = extractKeys(colourMappings);

let gridApi: GridApi;

const gridOptions: GridOptions = {
  columnDefs: [
    {
      field: "make",
      minWidth: 100,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: carCodes,
      },
      filter: "agSetColumnFilter",
      refData: carMappings,
    },
    {
      field: "exteriorColour",
      minWidth: 150,
      cellEditor: "agRichSelectCellEditor",
      cellEditorParams: {
        values: colourCodes,
        cellRenderer: ColourCellRenderer,
      },
      filter: "agSetColumnFilter",
      filterParams: {
        cellRenderer: ColourCellRenderer,
      },
      refData: colourMappings,
      cellRenderer: ColourCellRenderer,
    },
    {
      field: "interiorColour",
      minWidth: 150,
      filter: "agSetColumnFilter",
      filterParams: {
        cellRenderer: ColourCellRenderer,
      },
      refData: colourMappings,
      cellRenderer: ColourCellRenderer,
    },
    {
      headerName: "Retail Price",
      field: "price",
      minWidth: 120,
      colId: "retailPrice",
      valueGetter: (params) => {
        return params.data.price;
      },
      valueFormatter: currencyFormatter,
      valueSetter: numberValueSetter,
    },
    {
      headerName: "Retail Price (incl Taxes)",
      minWidth: 120,
      editable: false,
      valueGetter: (params) => {
        // example of chaining value getters
        return params.getValue("retailPrice") * 1.2;
      },
      valueFormatter: currencyFormatter,
    },
  ],
  defaultColDef: {
    flex: 1,
    filter: true,
    editable: true,
  },
  rowData: getData(),
  onCellValueChanged: onCellValueChanged,
};

function onCellValueChanged(params: CellValueChangedEvent) {
  // notice that the data always contains the keys rather than values after editing
  console.log("onCellValueChanged Data: ", params.data);
}

function currencyFormatter(params: ValueFormatterParams) {
  const value = Math.floor(params.value);

  if (isNaN(value)) {
    return "";
  }

  return "£" + value.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
}

function numberValueSetter(params: ValueSetterParams) {
  const valueAsNumber = parseFloat(params.newValue);
  if (isNaN(valueAsNumber) || !isFinite(params.newValue)) {
    return false; // don't set invalid numbers!
  }

  params.data.price = valueAsNumber;

  return true;
}

// wait for the document to be loaded, otherwise
// AG Grid will not find the div in the document.
// lookup the container we want the Grid to use
const eGridDiv = document.querySelector<HTMLElement>("#myGrid")!;

// create the grid passing in the div to use together with the columns & data we want to use
gridApi = createGrid(eGridDiv, gridOptions);
```

[Live example: Ref Data Property](https://www.ag-grid.com/archive/36.2.0/examples/reference-data/ref-data-property/typescript/)


---
product: "AG Grid"
title: "Reference Data"
description: "This section describes two different strategies for managing reference data in your application. Both approaches implement the same grid example so they can be easily compared."
framework: react
version: "36.2.0"
related:
    - title: "Cell Content"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-content/"
    - title: "Find"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/find/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/notes/"
    - title: "Styling Cells"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-styles/"
    - title: "Highlighting Changes"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/change-cell-renderers/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/tooltips/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-expressions/"
    - title: "View Refresh"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/view-refresh/"
    - title: "Cell Text Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/react-data-grid/cell-text-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Reference Data

This section describes two different strategies for managing reference data in your application. Both approaches implement the same grid example so they can be easily compared.

> **Note**
>
> The term **Reference Data** is used here in a general way to describe data which can be defined using a key / value pair relationship (e.g. `'tyt': 'Toyota'`). This data is typically static in nature, i.e. it is not expected to change between server requests.

The examples contained within this section use the following reference data. Note that the data returned from the server only contains codes (keys) which must be mapped to names (values) for display purposes.

```js
// data from server
const rowData = [
    { make: 'tyt', exteriorColour: 'fg', interiorColour: 'bw', price: 35000 },
    { make: 'frd', exteriorColour: 'bw', interiorColour: 'cb', price: 32000 },
    ...
]

// supporting reference data
const carMappings = {
    'tyt': 'Toyota',
    'frd': 'Ford',
    'prs': 'Porsche',
    'nss': 'Nissan'
};

const colourMappings = {
    'cb': 'Cadet Blue',
    'bw': 'Burlywood',
    'fg': 'Forest Green'
};
```

## Using Value Handlers

Value Handlers can be used to map keys contained within the row data to their corresponding display values. This approach involves more coding but allows for different data formats and offers more flexibility managing the data.

The main idea of this approach is to use a `valueFormatter` to convert the code (key) to a value which is displayed in the cell. Then use a `valueParser` to convert the name back to a code (key) when saving it down into the underlying data.

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'make',
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
            values: extractKeys(carMappings)
        },
        // convert code to value
        valueFormatter: params => {
            return lookupValue(carMappings, params.value);
        },
        // convert value to code
        valueParser: params => {
            return lookupKey(carMappings, params.newValue);
        }
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

> **Note**
>
> When editing using Cell Editors it's important to ensure the underlying data is updated with the codes (keys) rather than the values that are displayed in the cells.

When using the `TextCellEditor` with a `valueFormatter`, you may want to display the formatted text rather than the code when editing. In this case you should also include the `useFormatter` property as follows:

```js
cellEditor: 'agTextCellEditor',
cellEditorParams: {
    useFormatter: true
}
```

### Example: Value Handlers

The following example demonstrates how `Value Handlers` can be combined to work with reference data:

- **'Make' Column:** uses the built-in `'select'` Cell Editor. Mapped names are displayed in the dropdown list and selections are saved as `'make'` codes in the underlying data.
- **'Exterior Colour' Column:** uses the built-in `'richSelect'` Cell Editor. Mapped names are displayed in the dropdown list and selections are saved as `'colour'` codes in the underlying data.
- **'Interior Colour' Column:** uses a Text Cell Editor with `useFormatter=true`. Mapped names are displayed in the cells and edited values are saved as `'colour'` codes in the underlying data. (Note: a valid name must be entered or the value will be saved as undefined.)
- **Set Filters:** display a list of names rather than codes.
- **'Price' Columns:** additionally demonstrate the use of `valueGetters` and `valueSetters`.

#### Value Handlers

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ISetFilterParams,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  ValueSetterParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
import ColourCellRenderer from "./colourCellRenderer.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
  SelectEditorModule,
  TextEditorModule,
];

const carMappings = {
  tyt: "Toyota",
  frd: "Ford",
  prs: "Porsche",
  nss: "Nissan",
};

const colourMappings = {
  cb: "Cadet Blue",
  bw: "Burlywood",
  fg: "Forest Green",
};

function extractKeys(mappings: Record<string, string>) {
  return Object.keys(mappings);
}

const carCodes = extractKeys(carMappings);

const colourCodes = extractKeys(colourMappings);

function lookupValue(mappings: Record<string, string>, key: string) {
  return mappings[key];
}

function lookupKey(mappings: Record<string, string>, name: string) {
  const keys = Object.keys(mappings);
  for (let i = 0; i < keys.length; i++) {
    const key = keys[i];
    if (mappings[key] === name) {
      return key;
    }
  }
}

function currencyFormatter(params: ValueFormatterParams) {
  const value = Math.floor(params.value);
  if (isNaN(value)) {
    return "";
  }
  return "£" + value.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
}

function numberValueSetter(params: ValueSetterParams) {
  const valueAsNumber = parseFloat(params.newValue);
  if (isNaN(valueAsNumber) || !isFinite(params.newValue)) {
    return false; // don't set invalid numbers!
  }
  params.data.price = valueAsNumber;
  return true;
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "make",
      minWidth: 100,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: carCodes,
      },
      filterParams: {
        valueFormatter: (params: ValueFormatterParams) => {
          return lookupValue(carMappings, params.value);
        },
      },
      valueFormatter: (params) => {
        return lookupValue(carMappings, params.value);
      },
    },
    {
      field: "exteriorColour",
      minWidth: 150,
      cellEditor: "agRichSelectCellEditor",
      cellEditorParams: {
        values: colourCodes,
        cellRenderer: ColourCellRenderer,
      },
      filter: "agSetColumnFilter",
      filterParams: {
        values: colourCodes,
        valueFormatter: (params) => {
          return lookupValue(colourMappings, params.value);
        },
        cellRenderer: ColourCellRenderer,
      } as ISetFilterParams,
      valueFormatter: (params) => {
        return lookupValue(colourMappings, params.value);
      },
      valueParser: (params) => {
        return lookupKey(colourMappings, params.newValue);
      },
      cellRenderer: ColourCellRenderer,
    },
    {
      field: "interiorColour",
      minWidth: 150,
      cellEditor: "agTextCellEditor",
      cellEditorParams: {
        useFormatter: true,
      },
      filter: "agSetColumnFilter",
      filterParams: {
        values: colourCodes,
        valueFormatter: (params: ValueFormatterParams) => {
          return lookupValue(colourMappings, params.value);
        },
        cellRenderer: ColourCellRenderer,
      },
      valueFormatter: (params) => {
        return lookupValue(colourMappings, params.value);
      },
      valueParser: (params) => {
        return lookupKey(colourMappings, params.newValue);
      },
      cellRenderer: ColourCellRenderer,
    },
    {
      headerName: "Retail Price",
      field: "price",
      minWidth: 120,
      colId: "retailPrice",
      valueGetter: (params) => {
        return params.data.price;
      },
      valueFormatter: currencyFormatter,
      valueSetter: numberValueSetter,
    },
    {
      headerName: "Retail Price (incl Taxes)",
      minWidth: 120,
      editable: false,
      valueGetter: (params) => {
        // example of chaining value getters
        return params.getValue("retailPrice") * 1.2;
      },
      valueFormatter: currencyFormatter,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      filter: true,
      editable: true,
    };
  }, []);

  const onCellValueChanged = useCallback((params: CellValueChangedEvent) => {
    // notice that the data always contains the keys rather than values after editing
    console.log("onCellValueChanged Data: ", params.data);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            onCellValueChanged={onCellValueChanged}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Value Handlers](https://www.ag-grid.com/archive/36.2.0/examples/reference-data/ref-data-value-handler/reactFunctionalTs/)

## Using the 'refData' Property

Here we present the same example but this time using the `refData` ColDef property. This approach requires less coding and is more straightforward, but might not be flexible enough for scenarios involving more complex reference data formats.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refData` | `RefData` |  |  |  |

All that is required with this approach is to specify the `refData` and the grid will take care of the rest, as shown below:

```jsx
const [columnDefs, setColumnDefs] = useState([
    {
        field: 'make',
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
           values: extractKeys(carMappings)
        },
        refData: carMappings
    }
]);

<AgGridReact columnDefs={columnDefs} />
```

Like in the previous example using Value Handlers, where the underlying data contains codes, the grid will use the specified reference data to display the associated values in the cells and save down the codes (keys) in the data when editing.

When a column with `refData` is used as a pivot column, the mapped display values are also used for the pivot column group headers.

### Example: 'refData' Property

The following example demonstrates how the `refData` property simplifies working with reference data:

- **'Make' Column:** uses the built-in `'select'` Cell Editor with the `refData` property specified. Mapped names are displayed in the dropdown list and selections are saved as `'make'` codes in the underlying data.
- **'Exterior Colour' Column:** uses the built-in `'richSelect'` Cell Editor with the `refData` property specified. Mapped names are displayed in the dropdown list and selections are saved as `'colour'` codes in the underlying data.
- **'Interior Colour' Column:** uses a Text Cell Editor (not recommended) with `refData`. Mapped names are displayed in the cells but when editing, colour codes (`cb`,`bw`,`fg`) must be entered directly. As users should not know codes, the Text Cell Editor is not recommended for use with `refData` in real world applications.
- **Set Filters:** display a list of names rather than codes.
- **'Price' Columns:** additionally demonstrate the use of `valueGetters` and `valueSetters`.

#### Ref Data Property

```tsx
("use client");

import React, {
  useCallback,
  useMemo,
  useRef,
  useState,
  StrictMode,
} from "react";
import { createRoot } from "react-dom/client";
import { AgGridReact, AgGridProvider } from "ag-grid-react";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  ValueSetterParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";
import ColourCellRenderer from "./colourCellRenderer.tsx";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

const modules = [
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
  SelectEditorModule,
  TextEditorModule,
];

const carMappings = {
  tyt: "Toyota",
  frd: "Ford",
  prs: "Porsche",
  nss: "Nissan",
};

const colourMappings = {
  cb: "Cadet Blue",
  bw: "Burlywood",
  fg: "Forest Green",
};

function extractKeys(mappings: Record<string, string>) {
  return Object.keys(mappings);
}

const carCodes = extractKeys(carMappings);

const colourCodes = extractKeys(colourMappings);

function currencyFormatter(params: ValueFormatterParams) {
  const value = Math.floor(params.value);
  if (isNaN(value)) {
    return "";
  }
  return "£" + value.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
}

function numberValueSetter(params: ValueSetterParams) {
  const valueAsNumber = parseFloat(params.newValue);
  if (isNaN(valueAsNumber) || !isFinite(params.newValue)) {
    return false; // don't set invalid numbers!
  }
  params.data.price = valueAsNumber;
  return true;
}

const GridExample = () => {
  const containerStyle = useMemo(() => ({ width: "100%", height: "100%" }), []);
  const gridStyle = useMemo(() => ({ height: "100%", width: "100%" }), []);
  const [rowData, setRowData] = useState<any[]>(getData());
  const [columnDefs, setColumnDefs] = useState<ColDef[]>([
    {
      field: "make",
      minWidth: 100,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: carCodes,
      },
      filter: "agSetColumnFilter",
      refData: carMappings,
    },
    {
      field: "exteriorColour",
      minWidth: 150,
      cellEditor: "agRichSelectCellEditor",
      cellEditorParams: {
        values: colourCodes,
        cellRenderer: ColourCellRenderer,
      },
      filter: "agSetColumnFilter",
      filterParams: {
        cellRenderer: ColourCellRenderer,
      },
      refData: colourMappings,
      cellRenderer: ColourCellRenderer,
    },
    {
      field: "interiorColour",
      minWidth: 150,
      filter: "agSetColumnFilter",
      filterParams: {
        cellRenderer: ColourCellRenderer,
      },
      refData: colourMappings,
      cellRenderer: ColourCellRenderer,
    },
    {
      headerName: "Retail Price",
      field: "price",
      minWidth: 120,
      colId: "retailPrice",
      valueGetter: (params) => {
        return params.data.price;
      },
      valueFormatter: currencyFormatter,
      valueSetter: numberValueSetter,
    },
    {
      headerName: "Retail Price (incl Taxes)",
      minWidth: 120,
      editable: false,
      valueGetter: (params) => {
        // example of chaining value getters
        return params.getValue("retailPrice") * 1.2;
      },
      valueFormatter: currencyFormatter,
    },
  ]);
  const defaultColDef = useMemo<ColDef>(() => {
    return {
      flex: 1,
      filter: true,
      editable: true,
    };
  }, []);

  const onCellValueChanged = useCallback((params: CellValueChangedEvent) => {
    // notice that the data always contains the keys rather than values after editing
    console.log("onCellValueChanged Data: ", params.data);
  }, []);

  return (
    <AgGridProvider modules={modules}>
      <div style={containerStyle}>
        <div style={gridStyle}>
          <AgGridReact
            rowData={rowData}
            columnDefs={columnDefs}
            defaultColDef={defaultColDef}
            onCellValueChanged={onCellValueChanged}
          />
        </div>
      </div>
    </AgGridProvider>
  );
};

const root = createRoot(document.getElementById("root")!);
root.render(
  <StrictMode>
    <GridExample />
  </StrictMode>,
);
```

[Live example: Ref Data Property](https://www.ag-grid.com/archive/36.2.0/examples/reference-data/ref-data-property/reactFunctionalTs/)


---
product: "AG Grid"
title: "Reference Data"
description: "This section describes two different strategies for managing reference data in your application. Both approaches implement the same grid example so they can be easily compared."
framework: vue
version: "36.2.0"
related:
    - title: "Cell Content"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-content/"
    - title: "Find"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/find/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/notes/"
    - title: "Styling Cells"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-styles/"
    - title: "Highlighting Changes"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/change-cell-renderers/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/tooltips/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-expressions/"
    - title: "View Refresh"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/view-refresh/"
    - title: "Cell Text Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/vue-data-grid/cell-text-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Reference Data

This section describes two different strategies for managing reference data in your application. Both approaches implement the same grid example so they can be easily compared.

> **Note**
>
> The term **Reference Data** is used here in a general way to describe data which can be defined using a key / value pair relationship (e.g. `'tyt': 'Toyota'`). This data is typically static in nature, i.e. it is not expected to change between server requests.

The examples contained within this section use the following reference data. Note that the data returned from the server only contains codes (keys) which must be mapped to names (values) for display purposes.

```js
// data from server
const rowData = [
    { make: 'tyt', exteriorColour: 'fg', interiorColour: 'bw', price: 35000 },
    { make: 'frd', exteriorColour: 'bw', interiorColour: 'cb', price: 32000 },
    ...
]

// supporting reference data
const carMappings = {
    'tyt': 'Toyota',
    'frd': 'Ford',
    'prs': 'Porsche',
    'nss': 'Nissan'
};

const colourMappings = {
    'cb': 'Cadet Blue',
    'bw': 'Burlywood',
    'fg': 'Forest Green'
};
```

## Using Value Handlers

Value Handlers can be used to map keys contained within the row data to their corresponding display values. This approach involves more coding but allows for different data formats and offers more flexibility managing the data.

The main idea of this approach is to use a `valueFormatter` to convert the code (key) to a value which is displayed in the cell. Then use a `valueParser` to convert the name back to a code (key) when saving it down into the underlying data.

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'make',
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
            values: extractKeys(carMappings)
        },
        // convert code to value
        valueFormatter: params => {
            return lookupValue(carMappings, params.value);
        },
        // convert value to code
        valueParser: params => {
            return lookupKey(carMappings, params.newValue);
        }
    }
];
```

> **Note**
>
> When editing using Cell Editors it's important to ensure the underlying data is updated with the codes (keys) rather than the values that are displayed in the cells.

When using the `TextCellEditor` with a `valueFormatter`, you may want to display the formatted text rather than the code when editing. In this case you should also include the `useFormatter` property as follows:

```js
cellEditor: 'agTextCellEditor',
cellEditorParams: {
    useFormatter: true
}
```

### Example: Value Handlers

The following example demonstrates how `Value Handlers` can be combined to work with reference data:

- **'Make' Column:** uses the built-in `'select'` Cell Editor. Mapped names are displayed in the dropdown list and selections are saved as `'make'` codes in the underlying data.
- **'Exterior Colour' Column:** uses the built-in `'richSelect'` Cell Editor. Mapped names are displayed in the dropdown list and selections are saved as `'colour'` codes in the underlying data.
- **'Interior Colour' Column:** uses a Text Cell Editor with `useFormatter=true`. Mapped names are displayed in the cells and edited values are saved as `'colour'` codes in the underlying data. (Note: a valid name must be entered or the value will be saved as undefined.)
- **Set Filters:** display a list of names rather than codes.
- **'Price' Columns:** additionally demonstrate the use of `valueGetters` and `valueSetters`.

#### Value Handlers

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  ValueSetterParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import ColourCellRenderer from "./colourCellRendererVue";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
  SelectEditorModule,
  TextEditorModule,
]);

const carMappings = {
  tyt: "Toyota",
  frd: "Ford",
  prs: "Porsche",
  nss: "Nissan",
};

const colourMappings = {
  cb: "Cadet Blue",
  bw: "Burlywood",
  fg: "Forest Green",
};

function extractKeys(mappings: Record<string, string>) {
  return Object.keys(mappings);
}

const carCodes = extractKeys(carMappings);

const colourCodes = extractKeys(colourMappings);

function lookupValue(mappings: Record<string, string>, key: string) {
  return mappings[key];
}

function lookupKey(mappings: Record<string, string>, name: string) {
  const keys = Object.keys(mappings);
  for (let i = 0; i < keys.length; i++) {
    const key = keys[i];
    if (mappings[key] === name) {
      return key;
    }
  }
}

function currencyFormatter(params: ValueFormatterParams) {
  const value = Math.floor(params.value);
  if (isNaN(value)) {
    return "";
  }
  return "£" + value.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
}

function numberValueSetter(params: ValueSetterParams) {
  const valueAsNumber = parseFloat(params.newValue);
  if (isNaN(valueAsNumber) || !isFinite(params.newValue)) {
    return false; // don't set invalid numbers!
  }
  params.data.price = valueAsNumber;
  return true;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"
      @cell-value-changed="onCellValueChanged"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    ColourCellRenderer,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "make",
        minWidth: 100,
        cellEditor: "agSelectCellEditor",
        cellEditorParams: {
          values: carCodes,
        },
        filterParams: {
          valueFormatter: (params: ValueFormatterParams) => {
            return lookupValue(carMappings, params.value);
          },
        },
        valueFormatter: (params) => {
          return lookupValue(carMappings, params.value);
        },
      },
      {
        field: "exteriorColour",
        minWidth: 150,
        cellEditor: "agRichSelectCellEditor",
        cellEditorParams: {
          values: colourCodes,
          cellRenderer: "ColourCellRenderer",
        },
        filter: "agSetColumnFilter",
        filterParams: {
          values: colourCodes,
          valueFormatter: (params) => {
            return lookupValue(colourMappings, params.value);
          },
          cellRenderer: "ColourCellRenderer",
        } as ISetFilterParams,
        valueFormatter: (params) => {
          return lookupValue(colourMappings, params.value);
        },
        valueParser: (params) => {
          return lookupKey(colourMappings, params.newValue);
        },
        cellRenderer: "ColourCellRenderer",
      },
      {
        field: "interiorColour",
        minWidth: 150,
        cellEditor: "agTextCellEditor",
        cellEditorParams: {
          useFormatter: true,
        },
        filter: "agSetColumnFilter",
        filterParams: {
          values: colourCodes,
          valueFormatter: (params: ValueFormatterParams) => {
            return lookupValue(colourMappings, params.value);
          },
          cellRenderer: "ColourCellRenderer",
        },
        valueFormatter: (params) => {
          return lookupValue(colourMappings, params.value);
        },
        valueParser: (params) => {
          return lookupKey(colourMappings, params.newValue);
        },
        cellRenderer: "ColourCellRenderer",
      },
      {
        headerName: "Retail Price",
        field: "price",
        minWidth: 120,
        colId: "retailPrice",
        valueGetter: (params) => {
          return params.data.price;
        },
        valueFormatter: currencyFormatter,
        valueSetter: numberValueSetter,
      },
      {
        headerName: "Retail Price (incl Taxes)",
        minWidth: 120,
        editable: false,
        valueGetter: (params) => {
          // example of chaining value getters
          return params.getValue("retailPrice") * 1.2;
        },
        valueFormatter: currencyFormatter,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      filter: true,
      editable: true,
    });
    const rowData = ref<any[] | null>(getData());

    function onCellValueChanged(params: CellValueChangedEvent) {
      // notice that the data always contains the keys rather than values after editing
      console.log("onCellValueChanged Data: ", params.data);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
      onCellValueChanged,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Value Handlers](https://www.ag-grid.com/archive/36.2.0/examples/reference-data/ref-data-value-handler/vue3/)

## Using the 'refData' Property

Here we present the same example but this time using the `refData` ColDef property. This approach requires less coding and is more straightforward, but might not be flexible enough for scenarios involving more complex reference data formats.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refData` | `RefData` |  |  |  |

All that is required with this approach is to specify the `refData` and the grid will take care of the rest, as shown below:

```ts
<ag-grid-vue
    :columnDefs="columnDefs"
    /* other grid options ... */>
</ag-grid-vue>

this.columnDefs = [
    {
        field: 'make',
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
           values: extractKeys(carMappings)
        },
        refData: carMappings
    }
];
```

Like in the previous example using Value Handlers, where the underlying data contains codes, the grid will use the specified reference data to display the associated values in the cells and save down the codes (keys) in the data when editing.

When a column with `refData` is used as a pivot column, the mapped display values are also used for the pivot column group headers.

### Example: 'refData' Property

The following example demonstrates how the `refData` property simplifies working with reference data:

- **'Make' Column:** uses the built-in `'select'` Cell Editor with the `refData` property specified. Mapped names are displayed in the dropdown list and selections are saved as `'make'` codes in the underlying data.
- **'Exterior Colour' Column:** uses the built-in `'richSelect'` Cell Editor with the `refData` property specified. Mapped names are displayed in the dropdown list and selections are saved as `'colour'` codes in the underlying data.
- **'Interior Colour' Column:** uses a Text Cell Editor (not recommended) with `refData`. Mapped names are displayed in the cells but when editing, colour codes (`cb`,`bw`,`fg`) must be entered directly. As users should not know codes, the Text Cell Editor is not recommended for use with `refData` in real world applications.
- **Set Filters:** display a list of names rather than codes.
- **'Price' Columns:** additionally demonstrate the use of `valueGetters` and `valueSetters`.

#### Ref Data Property

```ts
import {
  createApp,
  defineComponent,
  onBeforeMount,
  ref,
  shallowRef,
} from "vue";
import { AgGridVue } from "ag-grid-vue3";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  ValueSetterParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import ColourCellRenderer from "./colourCellRendererVue";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
  SelectEditorModule,
  TextEditorModule,
]);

const carMappings = {
  tyt: "Toyota",
  frd: "Ford",
  prs: "Porsche",
  nss: "Nissan",
};

const colourMappings = {
  cb: "Cadet Blue",
  bw: "Burlywood",
  fg: "Forest Green",
};

function extractKeys(mappings: Record<string, string>) {
  return Object.keys(mappings);
}

const carCodes = extractKeys(carMappings);

const colourCodes = extractKeys(colourMappings);

function currencyFormatter(params: ValueFormatterParams) {
  const value = Math.floor(params.value);
  if (isNaN(value)) {
    return "";
  }
  return "£" + value.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
}

function numberValueSetter(params: ValueSetterParams) {
  const valueAsNumber = parseFloat(params.newValue);
  if (isNaN(valueAsNumber) || !isFinite(params.newValue)) {
    return false; // don't set invalid numbers!
  }
  params.data.price = valueAsNumber;
  return true;
}

const VueExample = defineComponent({
  template: `
        <div style="height: 100%">
                <ag-grid-vue
      style="width: 100%; height: 100%;"
      @grid-ready="onGridReady"
      :columnDefs="columnDefs"
      :defaultColDef="defaultColDef"
      :rowData="rowData"
      @cell-value-changed="onCellValueChanged"></ag-grid-vue>
        </div>
    `,
  components: {
    "ag-grid-vue": AgGridVue,
    ColourCellRenderer,
  },
  setup(props) {
    const gridApi = shallowRef<GridApi | null>(null);
    const columnDefs = ref<ColDef[]>([
      {
        field: "make",
        minWidth: 100,
        cellEditor: "agSelectCellEditor",
        cellEditorParams: {
          values: carCodes,
        },
        filter: "agSetColumnFilter",
        refData: carMappings,
      },
      {
        field: "exteriorColour",
        minWidth: 150,
        cellEditor: "agRichSelectCellEditor",
        cellEditorParams: {
          values: colourCodes,
          cellRenderer: "ColourCellRenderer",
        },
        filter: "agSetColumnFilter",
        filterParams: {
          cellRenderer: "ColourCellRenderer",
        },
        refData: colourMappings,
        cellRenderer: "ColourCellRenderer",
      },
      {
        field: "interiorColour",
        minWidth: 150,
        filter: "agSetColumnFilter",
        filterParams: {
          cellRenderer: "ColourCellRenderer",
        },
        refData: colourMappings,
        cellRenderer: "ColourCellRenderer",
      },
      {
        headerName: "Retail Price",
        field: "price",
        minWidth: 120,
        colId: "retailPrice",
        valueGetter: (params) => {
          return params.data.price;
        },
        valueFormatter: currencyFormatter,
        valueSetter: numberValueSetter,
      },
      {
        headerName: "Retail Price (incl Taxes)",
        minWidth: 120,
        editable: false,
        valueGetter: (params) => {
          // example of chaining value getters
          return params.getValue("retailPrice") * 1.2;
        },
        valueFormatter: currencyFormatter,
      },
    ]);
    const defaultColDef = ref<ColDef>({
      flex: 1,
      filter: true,
      editable: true,
    });
    const rowData = ref<any[] | null>(getData());

    function onCellValueChanged(params: CellValueChangedEvent) {
      // notice that the data always contains the keys rather than values after editing
      console.log("onCellValueChanged Data: ", params.data);
    }
    const onGridReady = (params: GridReadyEvent) => {
      gridApi.value = params.api;
    };

    return {
      gridApi,
      columnDefs,
      defaultColDef,
      rowData,
      onGridReady,
      onCellValueChanged,
    };
  },
});

const app = createApp(VueExample);
app.mount("#app");
```

[Live example: Ref Data Property](https://www.ag-grid.com/archive/36.2.0/examples/reference-data/ref-data-property/vue3/)


---
product: "AG Grid"
title: "Reference Data"
description: "This section describes two different strategies for managing reference data in your application. Both approaches implement the same grid example so they can be easily compared."
framework: angular
version: "36.2.0"
related:
    - title: "Cell Content"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-content/"
    - title: "Find"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/find/"
    - title: "Notes"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/notes/"
    - title: "Styling Cells"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-styles/"
    - title: "Highlighting Changes"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/change-cell-renderers/"
    - title: "Tooltips"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/tooltips/"
    - title: "Expressions"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-expressions/"
    - title: "View Refresh"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/view-refresh/"
    - title: "Cell Text Selection"
      url: "https://www.ag-grid.com/archive/36.2.0/angular-data-grid/cell-text-selection/"
llms: "https://www.ag-grid.com/archive/36.2.0/llms.txt"
---

# Reference Data

This section describes two different strategies for managing reference data in your application. Both approaches implement the same grid example so they can be easily compared.

> **Note**
>
> The term **Reference Data** is used here in a general way to describe data which can be defined using a key / value pair relationship (e.g. `'tyt': 'Toyota'`). This data is typically static in nature, i.e. it is not expected to change between server requests.

The examples contained within this section use the following reference data. Note that the data returned from the server only contains codes (keys) which must be mapped to names (values) for display purposes.

```js
// data from server
const rowData = [
    { make: 'tyt', exteriorColour: 'fg', interiorColour: 'bw', price: 35000 },
    { make: 'frd', exteriorColour: 'bw', interiorColour: 'cb', price: 32000 },
    ...
]

// supporting reference data
const carMappings = {
    'tyt': 'Toyota',
    'frd': 'Ford',
    'prs': 'Porsche',
    'nss': 'Nissan'
};

const colourMappings = {
    'cb': 'Cadet Blue',
    'bw': 'Burlywood',
    'fg': 'Forest Green'
};
```

## Using Value Handlers

Value Handlers can be used to map keys contained within the row data to their corresponding display values. This approach involves more coding but allows for different data formats and offers more flexibility managing the data.

The main idea of this approach is to use a `valueFormatter` to convert the code (key) to a value which is displayed in the cell. Then use a `valueParser` to convert the name back to a code (key) when saving it down into the underlying data.

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'make',
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
            values: extractKeys(carMappings)
        },
        // convert code to value
        valueFormatter: params => {
            return lookupValue(carMappings, params.value);
        },
        // convert value to code
        valueParser: params => {
            return lookupKey(carMappings, params.newValue);
        }
    }
];
```

> **Note**
>
> When editing using Cell Editors it's important to ensure the underlying data is updated with the codes (keys) rather than the values that are displayed in the cells.

When using the `TextCellEditor` with a `valueFormatter`, you may want to display the formatted text rather than the code when editing. In this case you should also include the `useFormatter` property as follows:

```js
cellEditor: 'agTextCellEditor',
cellEditorParams: {
    useFormatter: true
}
```

### Example: Value Handlers

The following example demonstrates how `Value Handlers` can be combined to work with reference data:

- **'Make' Column:** uses the built-in `'select'` Cell Editor. Mapped names are displayed in the dropdown list and selections are saved as `'make'` codes in the underlying data.
- **'Exterior Colour' Column:** uses the built-in `'richSelect'` Cell Editor. Mapped names are displayed in the dropdown list and selections are saved as `'colour'` codes in the underlying data.
- **'Interior Colour' Column:** uses a Text Cell Editor with `useFormatter=true`. Mapped names are displayed in the cells and edited values are saved as `'colour'` codes in the underlying data. (Note: a valid name must be entered or the value will be saved as undefined.)
- **Set Filters:** display a list of names rather than codes.
- **'Price' Columns:** additionally demonstrate the use of `valueGetters` and `valueSetters`.

#### Value Handlers

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ISetFilterParams,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  ValueSetterParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
  SelectEditorModule,
  TextEditorModule,
]);
import { ColourCellRenderer } from "./colour-cell-renderer.component";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, ColourCellRenderer],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (cellValueChanged)="onCellValueChanged($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "make",
      minWidth: 100,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: carCodes,
      },
      filterParams: {
        valueFormatter: (params: ValueFormatterParams) => {
          return lookupValue(carMappings, params.value);
        },
      },
      valueFormatter: (params) => {
        return lookupValue(carMappings, params.value);
      },
    },
    {
      field: "exteriorColour",
      minWidth: 150,
      cellEditor: "agRichSelectCellEditor",
      cellEditorParams: {
        values: colourCodes,
        cellRenderer: ColourCellRenderer,
      },
      filter: "agSetColumnFilter",
      filterParams: {
        values: colourCodes,
        valueFormatter: (params) => {
          return lookupValue(colourMappings, params.value);
        },
        cellRenderer: ColourCellRenderer,
      } as ISetFilterParams,
      valueFormatter: (params) => {
        return lookupValue(colourMappings, params.value);
      },
      valueParser: (params) => {
        return lookupKey(colourMappings, params.newValue);
      },
      cellRenderer: ColourCellRenderer,
    },
    {
      field: "interiorColour",
      minWidth: 150,
      cellEditor: "agTextCellEditor",
      cellEditorParams: {
        useFormatter: true,
      },
      filter: "agSetColumnFilter",
      filterParams: {
        values: colourCodes,
        valueFormatter: (params: ValueFormatterParams) => {
          return lookupValue(colourMappings, params.value);
        },
        cellRenderer: ColourCellRenderer,
      },
      valueFormatter: (params) => {
        return lookupValue(colourMappings, params.value);
      },
      valueParser: (params) => {
        return lookupKey(colourMappings, params.newValue);
      },
      cellRenderer: ColourCellRenderer,
    },
    {
      headerName: "Retail Price",
      field: "price",
      minWidth: 120,
      colId: "retailPrice",
      valueGetter: (params) => {
        return params.data.price;
      },
      valueFormatter: currencyFormatter,
      valueSetter: numberValueSetter,
    },
    {
      headerName: "Retail Price (incl Taxes)",
      minWidth: 120,
      editable: false,
      valueGetter: (params) => {
        // example of chaining value getters
        return params.getValue("retailPrice") * 1.2;
      },
      valueFormatter: currencyFormatter,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    filter: true,
    editable: true,
  };
  rowData: any[] | null = getData();

  onCellValueChanged(params: CellValueChangedEvent) {
    // notice that the data always contains the keys rather than values after editing
    console.log("onCellValueChanged Data: ", params.data);
  }
}

const carMappings = {
  tyt: "Toyota",
  frd: "Ford",
  prs: "Porsche",
  nss: "Nissan",
};
const colourMappings = {
  cb: "Cadet Blue",
  bw: "Burlywood",
  fg: "Forest Green",
};
function extractKeys(mappings: Record<string, string>) {
  return Object.keys(mappings);
}
const carCodes = extractKeys(carMappings);
const colourCodes = extractKeys(colourMappings);
function lookupValue(mappings: Record<string, string>, key: string) {
  return mappings[key];
}
function lookupKey(mappings: Record<string, string>, name: string) {
  const keys = Object.keys(mappings);
  for (let i = 0; i < keys.length; i++) {
    const key = keys[i];
    if (mappings[key] === name) {
      return key;
    }
  }
}
function currencyFormatter(params: ValueFormatterParams) {
  const value = Math.floor(params.value);
  if (isNaN(value)) {
    return "";
  }
  return "£" + value.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
}
function numberValueSetter(params: ValueSetterParams) {
  const valueAsNumber = parseFloat(params.newValue);
  if (isNaN(valueAsNumber) || !isFinite(params.newValue)) {
    return false; // don't set invalid numbers!
  }
  params.data.price = valueAsNumber;
  return true;
}
```

[Live example: Value Handlers](https://www.ag-grid.com/archive/36.2.0/examples/reference-data/ref-data-value-handler/angular/)

## Using the 'refData' Property

Here we present the same example but this time using the `refData` ColDef property. This approach requires less coding and is more straightforward, but might not be flexible enough for scenarios involving more complex reference data formats.

| Property | Type | Required | Default | Description |
| --- | --- | --- | --- | --- |
| `refData` | `RefData` |  |  |  |

All that is required with this approach is to specify the `refData` and the grid will take care of the rest, as shown below:

```ts
<ag-grid-angular
    [columnDefs]="columnDefs"
    /* other grid options ... */ />

this.columnDefs = [
    {
        field: 'make',
        cellEditor: 'agSelectCellEditor',
        cellEditorParams: {
           values: extractKeys(carMappings)
        },
        refData: carMappings
    }
];
```

Like in the previous example using Value Handlers, where the underlying data contains codes, the grid will use the specified reference data to display the associated values in the cells and save down the codes (keys) in the data when editing.

When a column with `refData` is used as a pivot column, the mapped display values are also used for the pivot column group headers.

### Example: 'refData' Property

The following example demonstrates how the `refData` property simplifies working with reference data:

- **'Make' Column:** uses the built-in `'select'` Cell Editor with the `refData` property specified. Mapped names are displayed in the dropdown list and selections are saved as `'make'` codes in the underlying data.
- **'Exterior Colour' Column:** uses the built-in `'richSelect'` Cell Editor with the `refData` property specified. Mapped names are displayed in the dropdown list and selections are saved as `'colour'` codes in the underlying data.
- **'Interior Colour' Column:** uses a Text Cell Editor (not recommended) with `refData`. Mapped names are displayed in the cells but when editing, colour codes (`cb`,`bw`,`fg`) must be entered directly. As users should not know codes, the Text Cell Editor is not recommended for use with `refData` in real world applications.
- **Set Filters:** display a list of names rather than codes.
- **'Price' Columns:** additionally demonstrate the use of `valueGetters` and `valueSetters`.

#### Ref Data Property

```ts
import { Component } from "@angular/core";
import { AgGridAngular } from "ag-grid-angular";
import {
  CellValueChangedEvent,
  ClientSideRowModelModule,
  ColDef,
  ColGroupDef,
  GridApi,
  GridOptions,
  GridReadyEvent,
  ModuleRegistry,
  SelectEditorModule,
  TextEditorModule,
  ValueFormatterParams,
  ValueSetterParams,
  enableDevValidations,
} from "ag-grid-community";
import {
  ColumnMenuModule,
  ColumnsToolPanelModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
} from "ag-grid-enterprise";
import { getData } from "./data";

if (process.env.NODE_ENV !== "production") {
  // Enable extended validations only for development
  enableDevValidations();
}

ModuleRegistry.registerModules([
  ClientSideRowModelModule,
  ColumnsToolPanelModule,
  ColumnMenuModule,
  ContextMenuModule,
  RichSelectModule,
  SetFilterModule,
  SelectEditorModule,
  TextEditorModule,
]);
import { ColourCellRenderer } from "./colour-cell-renderer.component";

@Component({
  selector: "my-app",
  standalone: true,
  imports: [AgGridAngular, ColourCellRenderer],
  template: `<ag-grid-angular
    style="width: 100%; height: 100%;"
    [columnDefs]="columnDefs"
    [defaultColDef]="defaultColDef"
    [rowData]="rowData"
    (cellValueChanged)="onCellValueChanged($event)"
  /> `,
})
export class AppComponent {
  columnDefs: ColDef[] = [
    {
      field: "make",
      minWidth: 100,
      cellEditor: "agSelectCellEditor",
      cellEditorParams: {
        values: carCodes,
      },
      filter: "agSetColumnFilter",
      refData: carMappings,
    },
    {
      field: "exteriorColour",
      minWidth: 150,
      cellEditor: "agRichSelectCellEditor",
      cellEditorParams: {
        values: colourCodes,
        cellRenderer: ColourCellRenderer,
      },
      filter: "agSetColumnFilter",
      filterParams: {
        cellRenderer: ColourCellRenderer,
      },
      refData: colourMappings,
      cellRenderer: ColourCellRenderer,
    },
    {
      field: "interiorColour",
      minWidth: 150,
      filter: "agSetColumnFilter",
      filterParams: {
        cellRenderer: ColourCellRenderer,
      },
      refData: colourMappings,
      cellRenderer: ColourCellRenderer,
    },
    {
      headerName: "Retail Price",
      field: "price",
      minWidth: 120,
      colId: "retailPrice",
      valueGetter: (params) => {
        return params.data.price;
      },
      valueFormatter: currencyFormatter,
      valueSetter: numberValueSetter,
    },
    {
      headerName: "Retail Price (incl Taxes)",
      minWidth: 120,
      editable: false,
      valueGetter: (params) => {
        // example of chaining value getters
        return params.getValue("retailPrice") * 1.2;
      },
      valueFormatter: currencyFormatter,
    },
  ];
  defaultColDef: ColDef = {
    flex: 1,
    filter: true,
    editable: true,
  };
  rowData: any[] | null = getData();

  onCellValueChanged(params: CellValueChangedEvent) {
    // notice that the data always contains the keys rather than values after editing
    console.log("onCellValueChanged Data: ", params.data);
  }
}

const carMappings = {
  tyt: "Toyota",
  frd: "Ford",
  prs: "Porsche",
  nss: "Nissan",
};
const colourMappings = {
  cb: "Cadet Blue",
  bw: "Burlywood",
  fg: "Forest Green",
};
function extractKeys(mappings: Record<string, string>) {
  return Object.keys(mappings);
}
const carCodes = extractKeys(carMappings);
const colourCodes = extractKeys(colourMappings);
function currencyFormatter(params: ValueFormatterParams) {
  const value = Math.floor(params.value);
  if (isNaN(value)) {
    return "";
  }
  return "£" + value.toString().replace(/(\d)(?=(\d{3})+(?!\d))/g, "$1,");
}
function numberValueSetter(params: ValueSetterParams) {
  const valueAsNumber = parseFloat(params.newValue);
  if (isNaN(valueAsNumber) || !isFinite(params.newValue)) {
    return false; // don't set invalid numbers!
  }
  params.data.price = valueAsNumber;
  return true;
}
```

[Live example: Ref Data Property](https://www.ag-grid.com/archive/36.2.0/examples/reference-data/ref-data-property/angular/)
